package rh213424;

import org.graphstream.algorithm.Toolkit;
import org.graphstream.graph.Graph;

import static org.graphstream.algorithm.Toolkit.averageDegree;

public class Propagation {
    /**
     * graphe du réseau
     */
    private Graph graph;

    public Propagation(Graph graph) {
        this.graph = graph;
    }
    /**
     * calcul la distribution des degrés <k²>
     * @return double
     */
    public  double  distributionDegre(){
        double d = 0.0;
        int[] tabDistributionDegres= Toolkit.degreeDistribution(graph);
        for (int i = 0; i < tabDistributionDegres.length; i++) {
            double moyenneDegre = (double) tabDistributionDegres[i] / graph.getNodeCount();
            if (tabDistributionDegres[i] > 0) {
                d += Math.pow(i, 2) * moyenneDegre;
            }
        }
        return d;
    }

    /**
     * Calcul du taux de propagation λ = β / μ
     */
    public static void tauxPropagation(){
        double beta = 1.0/7.0;
        double gama = 1.0/14.0;
        double taux = beta/gama;
        System.out.println("Le taux de propagation du virus est : "+taux);
    }

    /**
     * Calcule et affiche le seuil épidémique
     */
    public void seuilEpidemique(){
        double k2 = distributionDegre();
        System.out.println("La distribution des degrés <k²> de notre réseau est :"+k2);
        double k = averageDegree(graph);
        double seuil = k/k2;
        System.out.println("Le seuil épidémique du réseau est : "+seuil);
    }
}
